require "defines"

--VARIABLES--
local screanresolution={x = 0, y = 0}
local day_time=0
local day_time_h=0
local day_time_m=0
--END VARIABLES--

remote.add_interface("AdvEq", {	
	animation_onoff = function()
		if global.show_heal_animation ~= 1 then global.show_heal_animation = 1 else global.show_heal_animation = false end
		return true
	end,
	
	show_health = function()
		if global.show_life ~= 1 then global.show_life = 1 else global.show_life = false end
		return true
	end,
	
	show_timer = function(a)
		if a == 1 then global.show_timer = 1 else global.show_timer = false end
		return true
	end
})


script.on_init(function()
	global.healing = {}
	global.tick = 0
	global.show_heal_animation = true
	global.show_life = true
	global.show_timer = true
	global.version = "0.4.1"
end)

script.on_configuration_changed (function()
	if global.version == nil then
		global.healing = global.healing or {}
		global.tick = global.tick or 0
		global.show_heal_animation = global.show_heal_animation or true
		global.show_life = global.show_life or true
		global.show_timer = global.show_timer or true
		global.version = "0.4.1"
	end
end)

script.on_event(defines.events.on_tick, function(event)
	if global.tick == 5 then
		for _,_player in pairs(game.players) do
			local player = _player
			if player.connected then
				if global[player.name] == nil then
					global[player.name] = {}
					global[player.name].heal_effect=1
					global[player.name].healing=false
					global[player.name].lifeframe = nil
					global[player.name].timeframe = nil
				end
				
				if global.show_life and player.character ~= nil then
					if player.character.health < 100 then
						if global[player.name].lifeframe == nil then
							local top = player.gui.top
							local life_frame = top.life_frame
							if life_frame == nil then
								life_frame = top.add({type="frame", name="life_frame", caption="",direction="vertical", style="adveq"})
								life_frame.add{type="label", name="life", caption=""}
								life_frame.life.style.font="default-frame"
								life_frame.life.style.font_color = {r = 0, g = 0, b = 0}
								life_frame.style.maximal_width = 100
								life_frame.style.minimal_width = 100
							end
							global[player.name].lifeframe=life_frame
						end

						local health=player.character.health
						local healthint=math.floor(health)
						local healthdec=math.floor((health-healthint)*10)
						local frame = global[player.name].lifeframe.life
						
						health=healthint+(healthdec/10)
						frame.style.font_color = {r = 1-(player.character.health/100), g = (player.character.health/100), b = 0}
						frame.caption = "Life " .. health
						--screanresolution=player.real2screenposition(player.position)
						--player.gui.top.life.style.leftpadding = screanresolution.x/2
						--player.gui.top.life.style.maximalwidth=(screanresolution.x/2)+85
						if global.show_heal_animation and not global[player.name].healing then
							global[player.name].healing = true
							table.insert(global.healing,player)
						end
					end
				end
				
				if global.show_timer then
					if global[player.name].timeframe == nil then
						local top = player.gui.top
						local time_frame = top.time_frame
						if time_frame == nil then
							time_frame = top.add({type="frame", name="time_frame", caption="",direction="vertical", style="adveq"})
							time_frame.add{type="label", name="timeplace", caption=""}
							time_frame.timeplace.style.font="default-frame"
							time_frame.timeplace.style.font_color = {r = 1, g = 1, b = 1}
							time_frame.style.maximal_width = 100
							time_frame.style.minimal_width = 100
						end
						global[player.name].timeframe=time_frame.timeplace
					end
					local day_time=(game.daytime*24)+14
					local frame = global[player.name].timeframe
					if day_time<24 then
						local day_time_h=math.floor(day_time)
						local day_time_m=math.floor((day_time-day_time_h)*60)
						if day_time_m<10 then
							frame.caption ="Time: " .. day_time_h .. ":0" .. day_time_m .. ""
						else
							frame.caption ="Time: " .. day_time_h .. ":" .. day_time_m .. ""
						end
					else
						local day_time=day_time-24
						local day_time_h=math.floor(day_time)
						local day_time_m=math.floor((day_time-day_time_h)*60)
						if day_time_m<10 then
							frame.caption ="Time: " .. day_time_h .. ":0" .. day_time_m .. ""
						else
							frame.caption ="Time: " .. day_time_h .. ":" .. day_time_m .. ""
						end
					end
				else
					if global[player.name].timeframe ~= nil then
						global[player.name].timeframe.destroy()
						global[player.name].timeframe = nil
					end
				end
			end
		end
		global.tick = 0
	else
		global.tick = global.tick + 1
	end
	if global.healing ~= nil then
		for k,_player in pairs(global.healing) do
			local player = _player
			if player.connected then
				if player.character ~= nil then
					if player.character.health < 100 then
						player.surface.create_entity{name="heal-effect-"..global[player.name].heal_effect, position={player.position.x, player.position.y}}
						global[player.name].heal_effect = (global[player.name].heal_effect < 20) and global[player.name].heal_effect + 1 or 1
					else
						global.healing[k] = nil
						global[player.name].healing = false
						global[player.name].lifeframe.life.caption = ""
						global[player.name].lifeframe.destroy()
						global[player.name].lifeframe = nil
					end
				end
			end
		end
	end
end)